package gui.util;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JTextField;

public class PasteButton extends JButton {

	private static final long serialVersionUID = -995875068996782050L;

	public PasteButton(final JTextField dest,String text) {
		super(text);
		addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				dest.setText(GuiUtil.getClipboardString());
			}
		});
	}
	
}
